<?php

namespace CTT;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CompleteShipment' => '\\CTT\\StructType\\CompleteShipment',
            'CompleteShipmentResponse' => '\\CTT\\StructType\\CompleteShipmentResponse',
            'CreateShipment' => '\\CTT\\StructType\\CreateShipment',
            'CreateShipmentResponse' => '\\CTT\\StructType\\CreateShipmentResponse',
            'CreateShipmentWithoutPrint' => '\\CTT\\StructType\\CreateShipmentWithoutPrint',
            'CreateShipmentWithoutPrintResponse' => '\\CTT\\StructType\\CreateShipmentWithoutPrintResponse',
            'CloseShipment' => '\\CTT\\StructType\\CloseShipment',
            'CloseShipmentResponse' => '\\CTT\\StructType\\CloseShipmentResponse',
            'CompleteShipmentInput' => '\\CTT\\StructType\\CompleteShipmentInput',
            'CompleteShipmentOutput' => '\\CTT\\StructType\\CompleteShipmentOutput',
            'ArrayOfErrorData' => '\\CTT\\ArrayType\\ArrayOfErrorData',
            'ErrorData' => '\\CTT\\StructType\\ErrorData',
            'ArrayOfShipmentDataOutput' => '\\CTT\\ArrayType\\ArrayOfShipmentDataOutput',
            'ShipmentDataOutput' => '\\CTT\\StructType\\ShipmentDataOutput',
            'ArrayOfDocumentData' => '\\CTT\\ArrayType\\ArrayOfDocumentData',
            'DocumentData' => '\\CTT\\StructType\\DocumentData',
            'ArrayOfLabelData' => '\\CTT\\ArrayType\\ArrayOfLabelData',
            'LabelData' => '\\CTT\\StructType\\LabelData',
            'CreateShipmentInput' => '\\CTT\\StructType\\CreateShipmentInput',
            'CreateShipmentOutput' => '\\CTT\\StructType\\CreateShipmentOutput',
            'CloseShipmentInput' => '\\CTT\\StructType\\CloseShipmentInput',
            'ArrayOfShipment2Close' => '\\CTT\\ArrayType\\ArrayOfShipment2Close',
            'Shipment2Close' => '\\CTT\\StructType\\Shipment2Close',
            'CloseShipmentOutput' => '\\CTT\\StructType\\CloseShipmentOutput',
            'DeliveryNote' => '\\CTT\\StructType\\DeliveryNote',
            'ArrayOfShipmentCTT' => '\\CTT\\ArrayType\\ArrayOfShipmentCTT',
            'ShipmentCTT' => '\\CTT\\StructType\\ShipmentCTT',
            'DeliveryAggregationInf' => '\\CTT\\StructType\\DeliveryAggregationInf',
            'ArrayOfPIPAuthorizationData' => '\\CTT\\ArrayType\\ArrayOfPIPAuthorizationData',
            'PIPAuthorizationData' => '\\CTT\\StructType\\PIPAuthorizationData',
            'AddressData' => '\\CTT\\StructType\\AddressData',
            'ShipmentData' => '\\CTT\\StructType\\ShipmentData',
            'CargoData' => '\\CTT\\StructType\\CargoData',
            'CustomsData' => '\\CTT\\StructType\\CustomsData',
            'ArrayOfCustomsItemsData' => '\\CTT\\ArrayType\\ArrayOfCustomsItemsData',
            'CustomsItemsData' => '\\CTT\\StructType\\CustomsItemsData',
            'ArrayOfSpecialService' => '\\CTT\\ArrayType\\ArrayOfSpecialService',
            'SpecialService' => '\\CTT\\StructType\\SpecialService',
            'DDA' => '\\CTT\\StructType\\DDA',
            'DeliveryPointData' => '\\CTT\\StructType\\DeliveryPointData',
            'MultipleHomeDeliveryData' => '\\CTT\\StructType\\MultipleHomeDeliveryData',
            'ReturnAuthorizationData' => '\\CTT\\StructType\\ReturnAuthorizationData',
            'TimeWindowData' => '\\CTT\\StructType\\TimeWindowData',
        );
    }
}
