<?php

namespace CTT\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Close ServiceType
 * @subpackage Services
 */
class Close extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CloseShipment
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \CTT\StructType\CloseShipment $parameters
     * @return \CTT\StructType\CloseShipmentResponse|bool
     */
    public function CloseShipment(\CTT\StructType\CloseShipment $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CloseShipment($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \CTT\StructType\CloseShipmentResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
